//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const CREDIT_REDIR = 'http://www.flock.com/blogged-with-flock';

const RECENT_POSTS_NUMBER = 25;
var gParams;
var gB;
var gPostListUpdated = false;
var gPostPermalink = "";

function dump_rdf (data_source) {/*{{{*/
	var ser=Components.classes["@mozilla.org/rdf/xml-serializer;1"].createInstance(Components.interfaces.nsIRDFXMLSerializer);
	ser.init(data_source);
	var stream = {
		xml : '',
		close : function(){},
		flush : function(){},
		write : function (buffer,count) { 
			this.xml = this.xml+buffer; 
			return count; 
		},
		writeFrom : function (stream,count){},
		isNonBlocking: false
	};
	ser.QueryInterface(Components.interfaces.nsIRDFXMLSource).Serialize(stream);
	XXX("stream.xml",stream.xml);
}/*}}}*/

// nsISimpleEnumerator implementation {{{
function simpleEnumerator (aArray) {
    aArray.hasMoreElements = function () { 
        return this.length != 0; 
    }
    aArray.getNext = function () { 
        return this.shift (); 
    }
    return aArray;
} // }}}

function refreshBlogAPI(){
    var blogSettings = flock.blog.settings;
    var selectedBlog = "urn:flock:blog:settings:" + $("blog-account-selector").selectedItem.value;
    //var blogAccount = blogSettings.getAccount(selectedBlog);
    //gB = blogAccount.getBlogAPI();
    gB = flock.blog.service.getBlogAPI(selectedBlog);
}

function flock_blogMetadataLoad(){
  gParams  = window.arguments[0];

  // TODO: switch to the default blog (not the first one)
  var accts = $("blog-account-selector");
  if(!accts.selectedItem)
    accts.selectedIndex = 0;

  onChangeBlog();
}

function onChangeBlog(){
  refreshBlogAPI();
  // Enable categories if supported
  $('flock-blog-categories-container').setAttribute('collapsed', !gB.supportsCategories);
  window.sizeToContent();
  flock_blogEditorSetupCategories();
  if ((!refreshCategories.inProgress) && (gB.supportsCategories))
    refreshCategories.exec();
  // Update the post list if needed
  if ($('radio-update').selected) 
      flock_blogUpdatePostList();
}

function flock_blogEditorSetupCategories() {
    var blogSettings = flock.blog.settings;
    var selectedBlog = "urn:flock:blog:settings:" + $("blog-account-selector").selectedItem.value;
    var blogAccount = blogSettings.getAccount(selectedBlog);
    var ds = blogSettings.ds;
    $("flock-blog-categories").database.RemoveDataSource(ds.getRawDataSource());
    $("flock-blog-categories").database.AddDataSource(ds.getRawDataSource());
    $("flock-blog-categories").ref = blogAccount.getCategoriesRef();
    $("flock-blog-categories").builder.rebuild();
}

var refreshCategories = {
    exec: function() {
        var selectedBlog = "urn:flock:blog:settings:" + $("blog-account-selector").selectedItem.value;
        var blogAccount = flock.blog.settings.getAccount(selectedBlog);
        var B = blogAccount.getBlogAPI();
        blogAccount.flushCategories();
        this.inProgress = true;
        B.getCategoryList(this);
    },
    // Implement refresh listener
    onFault: function (aFault) {
        this.inProgress = false;
    },
    onResult: function (aResult) {
        //dump_rdf(aResult);
        var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                   getService(Components.interfaces.nsIRDFService);
        var theBlogs = aResult.GetAllResources();
        while (theBlogs.hasMoreElements())
        {
            theBlog = theBlogs.getNext();
            //dump("Found a blog... "+theBlog+"\n");
            var targets = aResult.ArcLabelsOut(theBlog);
            while (targets.hasMoreElements()){
              var predicate = targets.getNext();
              if (predicate instanceof Components.interfaces.nsIRDFResource){
                var target = aResult.GetTarget(theBlog, predicate, true);
                if (target instanceof Components.interfaces.nsIRDFResource){
                   //dump("Resource is: " + target.Value+"\n");
                }
                else if (target instanceof Components.interfaces.nsIRDFLiteral){
                   //dump("Literal is: "  + target.Value+"\n");
                } 
              }
            } 
            var categoryName = aResult.GetTarget(theBlog,
                rdfService.GetResource("http://www.flock.com/rdf/categoryName"), true).Value;
            var categoryId = aResult.GetTarget(theBlog,
                rdfService.GetResource("http://www.flock.com/rdf/categoryId"), true).Value;
            var blogSettings = flock.blog.settings;
            var selectedBlog = "urn:flock:blog:settings:" + $("blog-account-selector").selectedItem.value;
            flock.blog.service.addCategory(selectedBlog, categoryId, categoryName);
        }

        this.inProgress = false;
    },
    onError: function (aFault) {
        debugger;
        var strbundle = document.getElementById("blogStringBundle");
        alert(strbundle.getString("flock.blog.metadata.error.refreshingCategories"));
        this.inProgress = false;
    },
    inProgress: false,
}
 
function onRadioCheck(value){
   if (value == 1) {
        if (!gPostListUpdated)
            flock_blogUpdatePostList();
        $('blog-post-selector').setAttribute('disabled', 'false');
   }
   else {
        $('blog-post-selector').setAttribute('disabled', 'true');
   }
}
/*
function toggleAdvanced(checked){
   if (checked)
      $('advanced-metadata-box').setAttribute('collapsed', 'false');
   else
      $('advanced-metadata-box').setAttribute('collapsed', 'true');
} */

function flock_blogUpdatePostList(){
    gPostListUpdated = true;

    var strbundle = document.getElementById("blogStringBundle");
    var selectedBlog = "urn:flock:blog:settings:" + $("blog-account-selector").selectedItem.value;
    var listener = new populatePostList(selectedBlog);
    $('blog-post-selector').removeAllItems();
    $('blog-post-selector').setAttribute('label', strbundle.getString("flock.blog.metadata.loadingPostList"));
    gB.getRecentPosts(listener, RECENT_POSTS_NUMBER);
}

function populatePostList(selectedBlog, force_update) {
    this.selectedBlog = selectedBlog;
}

populatePostList.prototype = {
    onResult: function(result) 
    {
        var strbundle = document.getElementById("blogStringBundle");
        $('blog-post-selector').setAttribute('label', strbundle.getString("flock.blog.metadata.selectPost"));
        dump_rdf(result);
        var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                   getService(Components.interfaces.nsIRDFService);

        var posts = $('blog-post-selector');        
        var oldDataSources = posts.database.GetDataSources();
        while (oldDataSources.hasMoreElements()) {
          var theDataSource = oldDataSources.getNext();
          posts.database.RemoveDataSource(theDataSource);
        }
        posts.database.AddDataSource(result);
        posts.builder.rebuild();
     },
     onFault: function (fault)
     {
        var strbundle = document.getElementById("blogStringBundle");
        alert(strbundle.getString("flock.blog.metadata.error.retrievingPost"));
     },

     onError: function (error)
     {
        var strbundle = document.getElementById("blogStringBundle");
        alert(strbundle.getString("flock.blog.metadata.error.retrievingPost"));
     }
    
}

function blogCloseMetadata(){
    dump("CLOSING WINDOW");
    var selectedBlog = "urn:flock:blog:settings:" + $("blog-account-selector").selectedItem.value;
    var blogAccount = flock.blog.settings.getAccount(selectedBlog);
    dump(blogAccount.url+"\n");
    window.opener.published = true;
    if ($('view-on-your-blog').getAttribute('checked'))
        window.opener.permalink = blogAccount.url;
// $('view-on-your-blog').getAttribute('permalink');
    window.close();
}


function flock_blogEditorAddTags(html) {
    var tags = $("flock-blog-tags").value;
    var strbundle = document.getElementById("blogStringBundle");

    if(!tags || tags.length==0) return html;
    var tags_ar = tags.split(",");

    var tag_html = "";
    tag_html += '<!-- technorati tags begin -->';
    tag_html += '<p style="font-size:10px;text-align:right;">'
                + strbundle.getString("flock.blog.metadata.technoratiTags");


    for(var i=0;i<tags_ar.length;++i) {
        var tag = tags_ar[i];
        if(tag[0]=="\"") tag = tag.substring(1);
        if(tag[tag.length-1]=="\"") tag = tag.substring(tag,tag.length-1);

        tag_html += '<a href="http://technorati.com/tag/';
        tag_html += encodeURIComponent(tag);
        tag_html += '" rel="tag">';
        tag_html += tag;
        tag_html += '</a>';
        if(i!=tags_ar.length-1) {
            tag_html += ", ";
        }
    }

    tag_html += '</p>';
    tag_html +="<!-- technorati tags end -->";
    html += tag_html;

    return html;
}

function categorySupport() {
        if(!gSelectedBlog) return false;
        if(!gSelectedBlogAccountAPI) return false;
        if(gSelectedBlog.match(FLOCK_BLOG_DRAFTS_FOLDER)) return false;
        return !this.inProgress;
}


function xmlEscape(aString) {
  var result;
  result = aString.replace(/&/, "&amp;");
  result = result.replace(/</, "&lt;");
  result = result.replace(/>/, "&gt;");
  result = result.replace(/"/, "&quot;");
  return result;
}


function metadataPublishPost(){
  var strbundle = document.getElementById("blogStringBundle");
  var creditEntity = strbundle.getString("flock.blog.metadata.credit");
  const FLOCK_CREDIT = '<p style="text-align: right; font-size: 8px">'
  +creditEntity.replace('%1','<a href="' + CREDIT_REDIR + '" title="Flock" target="_new">Flock</a>')
  +'</p>';
  var newPost = !($('radio-update').selected);
  var html = flock_blogEditorAddTags(gParams.html);
  if ($('creditFlock').checked)
    html += FLOCK_CREDIT;

  var editURI = "";
  var atomid = "";
  var postid = "";
  var strbundle = document.getElementById("blogStringBundle");

  if (!newPost && !($('blog-post-selector').selectedItem)) {
    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);
    var msg = strbundle.getString("flock.blog.metadata.selectToReplace");
    prompts.alert(window, strbundle.getString("flock.blog.metadata.missingInfo"), msg);
    return;
  }

  if (!newPost){
    editURI = $('blog-post-selector').selectedItem.getAttribute("edituri");
    postid  = $('blog-post-selector').selectedItem.getAttribute("postid");
    atomid  = $('blog-post-selector').selectedItem.getAttribute("atomid");
  }

  window.success = false;
  // blogTriggerPublish(gB, gParams.title, html, editURI, newPost);
  var params = {
    blog: gB,
    title: xmlEscape(gParams.title),
    html: html,
    editURI: editURI,
    postid: postid,
    atomid: atomid,
    newPost: newPost
  };
  window.openDialog("blogPublish.xul", "publishDialog", "chrome,modal,centerscreen", params);
  if (window.success)
      blogCloseMetadata();

}

function viewBlogPost() {
    flock.browser.open(gPostPermalink, "window"); 
}

