var gPhoto;
var gSelectedApi;
var gPhotoMgrSvc;
var gPrefSvc;
var gTarget;
var gApiListener;

const PREF_SPREAD_FLOCK_SINGLE = 'flock.photo.singleUpload.spreadFlock';
const PREF_SPREAD_FLOCK_DISABLED = 'flock.photo.spreadFlock.is_disabled';
const PREF_TAGLINE = 'flock.photo.tagline';

function init() {
    // need to wrap in an array :/
    var uploadItems = Array();
    gPhoto = window.arguments[0].aPhoto;
    uploadItems.push(gPhoto);
    photoProperties.setUploadType(UPLOAD_TYPE_DND);
    photoProperties.setSelection(uploadItems);
    gTarget = window.arguments[0].aTarget;
    gPhotoMgrSvc = Components.classes['@flock.com/photo-api-manager;1?'].getService(Components.interfaces.flockIPhotoAPIManager);
    gPrefSvc = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
    
    // removing spread flock photo feature as it is half baked
    /*
    if (!gPrefSvc.getPrefType(PREF_SPREAD_FLOCK_DISABLED))
        gPrefSvc.setBoolPref(PREF_SPREAD_FLOCK_DISABLED, false);
    
    if (!gPrefSvc.getPrefType(PREF_SPREAD_FLOCK_SINGLE))
	gPrefSvc.setBoolPref(PREF_SPREAD_FLOCK_SINGLE, false);

    if (gPrefSvc.getBoolPref(PREF_SPREAD_FLOCK_DISABLED)) {
        document.getElementById('spread-flock-box').hidden = true;
    } else {
        if (!gPrefSvc.getPrefType(PREF_SPREAD_FLOCK_SINGLE)) {
    		gPrefSvc.setBoolPref(PREF_SPREAD_FLOCK_SINGLE, false);
    	}

    	if (gPrefSvc.getBoolPref(PREF_SPREAD_FLOCK_SINGLE)) {
    	    document.getElementById('flock-give-flock-props').checked = true;
    	}
    }
    */
        
    gApiListener = {
        onAPIStateChange: function(aAPI) {
            flock.photo.util.populateServicesPopup($('servicesMenuList').firstChild);
        }
    }
    gPhotoMgrSvc.addListener(gApiListener);
}

function unload() {
    gPhotoMgrSvc.removeListener(gApiListener);
}

function flock_updateSelectedAPI() {
    var selectedApi = $("flockPhotoservicesList").value;
    if (selectedApi) {
        gSelectedApi = gPhotoMgrSvc.getAPIFromShortname($("flockPhotoservicesList").value);
        $('bcasterServiceUploadSelected').removeAttribute('disabled');
        flock_updatePhotoOptionFields();
    } else {
        $('bcasterServiceUploadSelected').setAttribute('disabled', true);
    }
}

function flock_updatePhotoOptionFields() {
    flock_setupPhotoPropsUIFields(gSelectedApi);
}

function flock_launchSingleUpload() {
    var service = gPhotoMgrSvc.getDefaultService();

    var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
    var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
    var stringBundle = stringBundleService.createBundle("chrome://flock/locale/photo/photo.properties", localeService.getApplicationLocale());

    if (!service.isLoggedIn) {
     var loginListener = {
            onAuth: function() {
                if (gPhotoMgrSvc.getDefaultService().isLoggedIn) {
                    flock_launchUploadOptions();
                } 
            },
            
            onError: function(aError) {
            },
        }
       var message =  stringBundle.GetStringFromName("flock.photo.upload.er.open").replace(/%1/g, service.serviceName);
       message += "\n";
       message += stringBundle.GetStringFromName("flock.photo.upload.er.msg").replace('%1', service.serviceName);
       alert(message);
       
       // there is a bug in the apimanager which causes multiple state changes
       // which prevents us to use it -- for now call the login on the photoservice directly
       service.login(loginListener);
    } else {
        flock_launchUploadOptions();
    }
}

function flock_launchUploadOptions() {
    var params = {};
    var photoUploads = Array();

    photoUploads.push(window.arguments[0].aPhoto);
    params.photoUploads = photoUploads;
    params.aPhoto = window.arguments[0].aPhoto;
    params.aTarget = gTarget;
    params.numUploads = 1;
    var rv = window.openDialog("chrome://browser/content/flock/photo/flockPhotoUploadOptions.xul", "_blank", "modal,centerscreen", params);
    if (rv && params.launchUploader == true) {
     gPhoto.album = params.albumId;
     photoProperties.synch();
     flock_doSingleUpload();   
    } else {
    return false;    
   }
}

function flock_doSingleUpload() {
    var rval = {};
    var api = gPhotoMgrSvc.getDefaultService();
    window.openDialog("chrome://browser/content/flock/photo/uploadingSinglePhoto.xul", "UploadingSinglePhoto", "modal, centerscreen", api, gPhoto, rval);
    var photo = rval.photo;
    //todo: consolidate this code and with the other photo html stuff
    var html = "<a href=\"" + photo.webPageUrl + "\" > <img src=\"" + photo.largeSizePhoto + "\" border=\"0\"/>" + "</a>";

/*
    if (!gPrefSvc.getBoolPref(PREF_SPREAD_FLOCK_DISABLED)) {

    	gPrefSvc.setBoolPref(PREF_SPREAD_FLOCK_SINGLE, document.getElementById('flock-give-flock-props').checked);
	
    	if (gPrefSvc.getBoolPref(PREF_SPREAD_FLOCK_SINGLE)) {
    		var stringBundleSvc = Components.classes['@mozilla.org/intl/stringbundle;1']
    							  .getService(Components.interfaces.nsIStringBundleService);
    		var bundle = stringBundleSvc.createBundle("chrome://browser-region/locale/region.properties");
    		html += unescape(bundle.GetStringFromName('flock.photo.spread_flock_html'));
    		if (gPrefSvc.getPrefType(PREF_TAGLINE))
    		    html = html.replace(/%tagline%/g, gPrefSvc.getCharPref(PREF_TAGLINE));
    	}
    }
*/
    gTarget.value = gTarget.value + html;
    window.close();
    window.blur();
    return;
}   

function launchTaglineComposer() {
dump('>>>>>> launchTaglIneComposer\n\n')
    window.openDialog ("chrome://browser/content/flock/photo/taglineChooser.xul", "_blank", "modal,close,centerscreen");
}
